//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private joBracketBreakoutUtility[] cachejoBracketBreakoutUtility = null;

        private static joBracketBreakoutUtility checkjoBracketBreakoutUtility = new joBracketBreakoutUtility();

        /// <summary>
        /// Place on a second chart of the same instrument to see the Anchor Price during the entry phase of joBracketBreakout strategy
        /// </summary>
        /// <returns></returns>
        public joBracketBreakoutUtility joBracketBreakoutUtility(int iD)
        {
            return joBracketBreakoutUtility(Input, iD);
        }

        /// <summary>
        /// Place on a second chart of the same instrument to see the Anchor Price during the entry phase of joBracketBreakout strategy
        /// </summary>
        /// <returns></returns>
        public joBracketBreakoutUtility joBracketBreakoutUtility(Data.IDataSeries input, int iD)
        {
            if (cachejoBracketBreakoutUtility != null)
                for (int idx = 0; idx < cachejoBracketBreakoutUtility.Length; idx++)
                    if (cachejoBracketBreakoutUtility[idx].ID == iD && cachejoBracketBreakoutUtility[idx].EqualsInput(input))
                        return cachejoBracketBreakoutUtility[idx];

            lock (checkjoBracketBreakoutUtility)
            {
                checkjoBracketBreakoutUtility.ID = iD;
                iD = checkjoBracketBreakoutUtility.ID;

                if (cachejoBracketBreakoutUtility != null)
                    for (int idx = 0; idx < cachejoBracketBreakoutUtility.Length; idx++)
                        if (cachejoBracketBreakoutUtility[idx].ID == iD && cachejoBracketBreakoutUtility[idx].EqualsInput(input))
                            return cachejoBracketBreakoutUtility[idx];

                joBracketBreakoutUtility indicator = new joBracketBreakoutUtility();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.ID = iD;
                Indicators.Add(indicator);
                indicator.SetUp();

                joBracketBreakoutUtility[] tmp = new joBracketBreakoutUtility[cachejoBracketBreakoutUtility == null ? 1 : cachejoBracketBreakoutUtility.Length + 1];
                if (cachejoBracketBreakoutUtility != null)
                    cachejoBracketBreakoutUtility.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachejoBracketBreakoutUtility = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Place on a second chart of the same instrument to see the Anchor Price during the entry phase of joBracketBreakout strategy
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.joBracketBreakoutUtility joBracketBreakoutUtility(int iD)
        {
            return _indicator.joBracketBreakoutUtility(Input, iD);
        }

        /// <summary>
        /// Place on a second chart of the same instrument to see the Anchor Price during the entry phase of joBracketBreakout strategy
        /// </summary>
        /// <returns></returns>
        public Indicator.joBracketBreakoutUtility joBracketBreakoutUtility(Data.IDataSeries input, int iD)
        {
            return _indicator.joBracketBreakoutUtility(input, iD);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Place on a second chart of the same instrument to see the Anchor Price during the entry phase of joBracketBreakout strategy
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.joBracketBreakoutUtility joBracketBreakoutUtility(int iD)
        {
            return _indicator.joBracketBreakoutUtility(Input, iD);
        }

        /// <summary>
        /// Place on a second chart of the same instrument to see the Anchor Price during the entry phase of joBracketBreakout strategy
        /// </summary>
        /// <returns></returns>
        public Indicator.joBracketBreakoutUtility joBracketBreakoutUtility(Data.IDataSeries input, int iD)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.joBracketBreakoutUtility(input, iD);
        }
    }
}
#endregion
